{$WARNINGS OFF}
//=============================================================================
//  EditLibraryPath
//
//  CupX̕ҏWptH[̃jbg
//=============================================================================
unit EditLibraryPath;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, AppEvnts;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    btnAdd: TButton;
    btnDelete: TButton;
    Panel2: TPanel;
    btnAddDelphiPath: TButton;
    ListView1: TListView;
    ApplicationEvents1: TApplicationEvents;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnAddClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnAddDelphiPathClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    FIniFilename : string;
    FConfigFile  : string;
    FTabName     : string;
    procedure AddOriginLibPath(APath: string);
  public
    { Public 錾 }
  end;

var
  Form2: TForm2;

implementation

uses 
  FileCtrl,
  IniFiles,
  ShellAPI,
  CommandLineCompileUnit;

{$R *.dfm}

//=============================================================================
//  tH[̏
//  init@CƃCuoXۑĂt@Cǂݏoĕ\
//=============================================================================
procedure TForm2.FormCreate(Sender: TObject);
var
  LIniFile  : TIniFile;
  LFormLeft : Integer;
  LStrList  : TStringList;
  LLoopCnt  : Integer;
begin
  btnDelete.Enabled := False;

  FIniFilename := Form1.FIniFileName;
  FTabName     := Form1.TabControl1.Tabs[Form1.TabControl1.TabIndex];
  FConfigFile  := 'LibPath' + FTabName + '.CFG';

  Self.Caption := Self.Caption + ' ' + FTabName;
  LFormLeft   := 0;

  LIniFile := TIniFile.Create(FIniFileName);
  try
    if FileExists(FIniFileName) then begin
      LFormLeft   := LIniFile.ReadInteger('Common', 'EditFormLeft',   0);
      Self.Top    := LIniFile.ReadInteger('Common', 'EditFormTop',    Top);
      Self.Width  := LIniFile.ReadInteger('Common', 'EditFormWidth',  Width);
      Self.Height := LIniFile.ReadInteger('Common', 'EditFormHeight', Height);
    end;
  finally
    FreeAndNil(LIniFile);
  end;

  if LFormLeft = 0 then begin
    Self.Position := poMainFormCenter;
  end else begin
    Self.Position := poDesigned;
    Self.Left := LFormLeft;
  end;

  ListView1.Items.Clear;
  LStrList := TStringList.Create;
  LStrList.Sorted := True;
  LStrList.Duplicates := dupIgnore;
  try
    if FileExists(FConfigFile) then begin
      LStrList.LoadFromFile(FConfigFile);
      for LLoopCnt := 0 to LStrList.Count - 1 do begin
        if Trim(LStrList[LLoopCnt]) <> '' then begin
          ListView1.Items.Add.Caption := Trim(LStrList[LLoopCnt]);
        end;
      end;
    end else begin
      //DelphipX捞
      btnAddDelphiPathClick(nil);
    end;
  finally
    FreeAndNil(LStrList);
  end;

  //hbOAhhbv
  //usesShellAPIKv
  DragAcceptFiles(ListView1.Handle, True);
end;

//=============================================================================
//  tH[鎞݂͌̐ݒlۑ
//  ۑ̂́CCupXƂ̃tH[̕\ʒuƃTCY
//=============================================================================
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
var
  LStrList : TStringList;
  LIniFile : TIniFile;
  LStr     : string;
  LIndex   : Integer;
begin
  LStrList := TStringList.Create;
  try
    for LIndex := 0 to ListView1.Items.Count - 1 do begin
      LStr := Trim(ListView1.Items[LIndex].Caption);
      if LStr <> '' then LStrList.Add(LStr);
    end;
    LStrList.SaveToFile(FConfigFile);
  finally
    FreeAndNil(LStrList);
  end;

  LIniFile := TIniFile.Create(FIniFileName);
  try
    LIniFile.WriteInteger('Common', 'EditFormTop',    Self.Top);
    LIniFile.WriteInteger('Common', 'EditFormLeft',   Self.Left);
    LIniFile.WriteInteger('Common', 'EditFormWidth',  Self.Width);
    LIniFile.WriteInteger('Common', 'EditFormHeight', Self.Height);
  finally
    FreeAndNil(LIniFile);
  end;
end;

//=============================================================================
//  tH[TCYListView̕\ύX
//=============================================================================
procedure TForm2.FormResize(Sender: TObject);
begin
  ListView1.Column[0].Width := ListView1.ClientWidth - GetSystemMetrics(SM_CXHSCROLL);
end;

//=============================================================================
//  [ǉ]
//  tH_I_CAO\đI
//  tH_́CInit@CɕۑĂlgp
//  ꂪȂ΂̃vOtH_
//  tH_I炻̃tH_Init@CɋL^Ă
//=============================================================================
procedure TForm2.btnAddClick(Sender: TObject);
var
  LIniFile  : TIniFile;
  LBasePath : string;
begin
  LIniFile := TIniFile.Create(FIniFileName);

  try
    if FileExists(FIniFileName)then begin
      LBasePath := LIniFile.ReadString('Common', 'EditBasePath', '');
    end else begin
      LBasePath := ExtractFileDir(Application.ExeName);
    end;

    if SelectDirectory('CupXǉ', '', LBasePath) then begin
      AddOriginLibPath(ExcludeTrailingPathDelimiter(LBasePath));
      LIniFile.WriteString('Common', 'EditBasePath', LBasePath);
    end;
  finally
    FreeAndNil(LIniFile);
  end;
  btnDelete.Enabled := False;
end;

//=============================================================================
//  [폜]
//  ݑI𒆂̃pX̐ݒ폜
//=============================================================================
procedure TForm2.btnDeleteClick(Sender: TObject);
begin
  ListView1.DeleteSelected;
end;

//=============================================================================
//  [DelphipX捞]
//  DelphiIDEŐݒ肵Ă郉CupXǉ
//=============================================================================
procedure TForm2.btnAddDelphiPathClick(Sender: TObject);
var
  LStrList    : TStringList;
  LStrListAdd : TStringList;
  LStr        : string;
  LIndex      : Integer;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;

  LStrList    := TStringList.Create;
  LStrListAdd := TStringList.Create;
  LStrList.Sorted     := True;
  LStrList.Duplicates := dupIgnore;

  for LIndex := 0 to ListView1.Items.Count -1 do begin
    LStr := Trim(ListView1.Items[LIndex].Caption);
    if LStr <> ''  then LStrList.Add(LStr);
  end;
  try
    Form1.SetDefaultLibPath(FTabName, FConfigFile, LStrListAdd);
    for LIndex := 0 to LStrListAdd.Count - 1 do begin
      LStr := Trim(LStrListAdd[LIndex]);
      if LStr <> '' then LStrList.Add(LStrListAdd[LIndex]);
    end;
    for LIndex := 0 to LStrList.Count - 1 do begin
      ListView1.Items.Add.Caption := LStrList[LIndex];
    end;
  finally
    FreeAndNil(LStrList);
    FreeAndNil(LStrListAdd);
  end;

  ListView1.Items.EndUpdate;
  btnDelete.Enabled := False;
end;

//=============================================================================
//  Xgr[NbNC[폜]{^Enabledݒ
//=============================================================================
procedure TForm2.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  btnDelete.Enabled := ListView1.SelCount > 0;
end;

//=============================================================================
//  GNXv[̃t@C̃hbOEhbv
//  1̏ꍇ̂ݗL
//=============================================================================
procedure TForm2.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
var
  LCount     : Integer;
  LBuffer    : array [0..MAX_PATH] of Char;
  LDragPath  : string;
begin
  if Msg.message = WM_DROPFILES then begin
    if (FindDragTarget(Msg.pt, False) = ListView1) then begin
      LCount := DragQueryFile(Msg.wParam, High(DWORD), nil, 0);
      try
        if LCount = 1 then begin
          LDragPath := '';
          DragQueryFile(Msg.WParam, 0, LBuffer, MAX_PATH);
          LDragPath := LBuffer;
          AddOriginLibPath(LDragPath);
        end;
      finally
        //hbvƂ`
        DragFinish(msg.WParam);
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  CupX,APathǉ
//  dȂ߂̏p֐
//-----------------------------------------------------------------------------
procedure TForm2.AddOriginLibPath(APath: string);
var
  LStrList : TStringList;
  LStr     : string;
  LIndex   : Integer;
begin
  //d邽߂ɃpX̃XgxTStringList ޔ
  LStrList := TStringList.Create;
  LStrList.Sorted     := True;
  LStrList.Duplicates := dupIgnore;
  for LIndex := 0 to ListView1.Items.Count -1 do begin
    LStr := Trim(ListView1.Items[LIndex].Caption);
    if LStr <> ''  then LStrList.Add(LStr);
  end;

  //TStringListɑޔ̂TListView̓NA
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;

  try
    if DirectoryExists(APath) then begin
      LStrList.Add(APath);
    end;

    //쐬pXXgTListViewɕ\
    for LIndex := 0 to LStrList.Count - 1 do begin
      ListView1.Items.Add.Caption := LStrList[LIndex];
    end;
  finally
    FreeAndNil(LStrList);
  end;

  ListView1.Items.EndUpdate;
  btnDelete.Enabled := False;
end;

end.
